/* Anti Web HTTPD */
/* HardCore Software */
/* 
This software us Copyright (C) 2001 By HardCore Software.
The software is distributed under the terms of the GNU General Public
License. See the file 'LICENSE' for more details.
*/

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <netdb.h>
#include <signal.h>
#include <unistd.h>
#include <sys/time.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <sys/wait.h>
#include <arpa/inet.h>
#include <syslog.h>
#include <ctype.h>
#include <dirent.h>
#include <sys/stat.h>
#include <sys/dir.h>
#include <time.h>

#include "config.h"
#include "awhttpd.h"

/* Global Variables */
int pid,bindfd,tempfd;
struct sockaddr_in my_addr;
struct sockaddr_in their_addr;

#include "misc.c"
#include "sendstats.c"
#include "permcheck.c"
#include "procscrpt.c"
#include "procin.c"
#include "procout.c"
#include "proclog.c"
#include "urldecode.c"


int main(int argc, char *argv[]) {

int i,sin_size,opensock; char buf[MAXDATASIZE];
fd_set rfds; struct timeval tv; int anytoread;
tv.tv_sec = 0; tv.tv_usec = SELECTTIMEOUT;


if ((argc != 3) && (argc != 2)) usage();

/* SIGNALS */
signal(SIGINT, die); 
signal(SIGQUIT, die);
signal(SIGTERM, die);
signal(SIGPIPE, nada);

#ifdef LOGLEVEL
  openlog("AWHTTPD",LOG_CONS,LOG_USER);
#endif

starttime = bpstime = time(NULL);

/* Adminstrative memory bull. */
for (i=0;i<=MAXUSERS-1;i++) {
  getreqs[i]=malloc(MAXGETREQSIZE);
  memset(getreqs[i],0,MAXGETREQSIZE);
  ipaddrs[i]=malloc(16);
  memset(ipaddrs[i],0,16);
  sending[i]=0;
  charsread[i]=-1;
  filelen[i]=0;
  reqtype[i]=0;
  infd[i]=-1;
  filefd[i]=(FILE *) -1;
}

/* Make sure command line arguments are cool and with it. */
strncpy(cnfdir,argv[1],sizeof(cnfdir));
parsecnfdir();

if (argc==3) {
  cnfport=atoi(argv[2]);
} else {
  cnfport=80;
}

serverinit();
sin_size = sizeof(struct sockaddr_in);


/* Ok, switch UID now... */
#ifdef UIDTORUNAS
  if (setgid(UIDTORUNAS)<0)
          logthis(2,"Unable to change GID!");
  if (setuid(UIDTORUNAS)<0) 
          logthis(2,"Unable to change UID!");
#endif


#ifdef NOFORK
  pid = getpid();
  status();
#endif

#ifndef NOFORK
pid = fork();

if(pid > 0) { 
  logthis(3,"Anti-Web started!");
  status();
  exit(1);
} else if(pid == -1) {
  fprintf(stderr,"Anti-Web: Sorry, fork failed... Tough dice.\n");
  logthis(1,"Unable to fork process!");
  exit(0);
}
#endif


/* Switch directories AFTER UID has been switched. */
if (chdir(cnfdir) != 0) {
  logthis(2,"Unable to switch directories (non-fatal). error follows: ");
  logthis(2, strerror(errno));
}

while(1) {  /* main accept() loop */

if (numofusers==0) {
  /*If there are no users download a file currently,
    raise the select timeout to preserve CPU cycles. */
  tv.tv_sec = 0; tv.tv_usec = SELECTTIMEOUT;
} else {
  tv.tv_sec = 0; tv.tv_usec = 0;
}

procbps();

/* ULTRA COMPLEX NEW CONNECTIONS CHECKPOINT */
     /* BTW, select() has been my biggest programming headache in this
        entire project... And I'm still not sure if it's working right! */
       /* 2.1 update: Nah, it's working fine. I think there might be a
          better way to handle it though... */

FD_ZERO(&rfds); FD_SET(bindfd, &rfds);
anytoread=select(FD_SETSIZE, &rfds, NULL, NULL, &tv);

if (FD_ISSET(bindfd, &rfds)) {
  opensock=0;
  verifytimeconnected();
  while((opensock<MAXUSERS) && (infd[opensock]!=-1)) opensock++;
  if (opensock >= MAXUSERS) {
    if ((tempfd = accept(bindfd, (struct sockaddr *)&their_addr, &sin_size)) == -1){ logthis(2,"Error in the accept call"); continue;  }
    logthis(3,"Turned away a connection: Server full");
    send403(tempfd,1);
    close(tempfd);
  } else {
if ((infd[opensock] = accept(bindfd, (struct sockaddr *)&their_addr, &sin_size)) == -1){ logthis(2,"Error in the accept call"); continue;  }
  snprintf(buf, sizeof(buf),"%s",inet_ntoa(their_addr.sin_addr));
  strncpy(ipaddrs[opensock],buf,16);
  gettimeofday(&timeon[opensock],NULL);
  verifyconnsperip(opensock);
  }
}


/* ULTRA COMPLEX INCOMING DATA CHECKPOINT */
/* LOOK at this thing! Somebody shoot me! */

for(i=0;i<=MAXUSERS-1;i++) {
  if (sending[i]==1) processoutgoing(i);
  #ifdef SCRIPTING
  if (sending[i]==2) processscript(i);
  #endif

  if (infd[i]!=-1) {
    FD_ZERO(&rfds); FD_SET(infd[i], &rfds);
    /* FIXME: Try setting tv to 0 here... */
    tv.tv_sec = 0; tv.tv_usec = 0;
    anytoread=select(FD_SETSIZE, &rfds, NULL, NULL, &tv);
    
    if (FD_ISSET(infd[i], &rfds)) {
      memset(buf,0,MAXDATASIZE);
      
      if (read(infd[i],buf,MAXDATASIZE)==0) {
        discon(i);
      } else {
        if (sending[i]==0) processincoming(i,buf);
      }
      
    }
    
  }
}


} /* End of Main accept loop */

logthis(1,"Something is seriously fucked up...");
return -1; /* Should never get here! */

} /* End of main */
