/* Anti Web HTTPD */
/* HardCore Software */
/*
This software us Copyright (C) 2001 By HardCore Software.
The software is distributed under the terms of the GNU General Public
License. See the file 'LICENSE' for more details.
*/


/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 * This is the config.h file for Anti-Web.
 * Please customize to your own needs and refer to MANUAL
 * whenever necessary.
 * Normal users will probably only need to edit the BASIC CONFIGURATION.
 *
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/


/* BASIC CONFIGURATION: */

#define MAXUSERS 100 /* Maximum connections at once */
#define MAXCONNSPERIP 5 /* Maximum connections per IP. 0 for no limit */
#define USERTIMEOUT 5 /* Time the client is allowed to enter a GET in secs */
#define UIDTORUNAS 32767 /* UID/GID to run awhttpd as after binding... */
#define LOGLEVEL 3     /* Amount to log. See: "MANUAL" for info */


/* ADVANCED CONFIGURATION: */

/* #define CHARSET "ISO-8859-1" */ /* Define to send Content-type charset */
#define FOLLOWSYMLINKS /* AW will only follow symlinks if this is defined */
#define SENDLASTMODIFIED /* Send the client the file's last mod. time? */
#define HIDEFILESSTARTINGWITHADOT 1 /* Send files starting with a "."? */
#define HIDDENPREFIX "aw_" /* Files starting with this will never be sent */
/* #define BIND_ADDR "127.0.0.1" */ /* Bind only to the specified IP */
#define URLDECODE /* URL Decoding from Zas */
#define STARTFILE "index.html" /* File to look for on startup */
#define INDEXFILE "index.html" /* File to look for in each directory */
/* #define UNIPOINT "index.html" */ /* If defined, all requests will point to this file */
#define PERMCHECK    /* If defined, will run permission checks at startup */
#define SENDMIMETYPE /* If defined, will send mime types */
#define HEADREQ /* If defined, AW will reply to HEAD requests */
/* #define SENDSTATS "mypass" */  /* Will enable AW Web STATs with specified password */


/* SCRIPTING OPTIONS */

/* #define SCRIPTING */  /* Enable ANTI-WEB scripting? */
#define SCRIPTCATCH /* Don't send script files if scripting is disabled */


/* PERFORMANCE TWEAKING: */

#define SELECTTIMEOUT 10000 /* Timeout on the select() call */
#define MTU 5000 /* Most bytes to send per user per turn */




/* HACKERS: */

/* #define WINDOWS */ /* Undefine to cripple Anti-Web for a Windows compile */
/* #define NOFORK */ /* Not go into the background */
#define BACKLOG 10     /* pending connections to hold */
#define MAXDATASIZE 1000 /* Internal size. Leave at 1000 */




/* VERSION INFO: */

#define VERSION "2.2.7" /* Version string */
#define COOLQUOTE "Fear and loathing on the WWW"
